const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const commissions = sequelize.define(
    'commissions',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

commission_code: {
        type: DataTypes.TEXT,
      
      

      },

commission_status: {
        type: DataTypes.ENUM,
      
      

        values: [

"pending",


"approved",


"payable",


"paid",


"reversed",


"cancelled"

        ],

      },

commission_type: {
        type: DataTypes.ENUM,
      
      

        values: [

"sale",


"referral",


"bonus",


"adjustment"

        ],

      },

base_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

commission_amount: {
        type: DataTypes.DECIMAL,
      
      

      },

earned_at: {
        type: DataTypes.DATE,
      
      

      },

approved_at: {
        type: DataTypes.DATE,
      
      

      },

paid_at: {
        type: DataTypes.DATE,
      
      

      },

notes: {
        type: DataTypes.TEXT,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  commissions.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity




























//end loop



    db.commissions.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.orders, {
      as: 'order',
      foreignKey: {
        name: 'orderId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.order_items, {
      as: 'order_item',
      foreignKey: {
        name: 'order_itemId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.users, {
      as: 'beneficiary_user',
      foreignKey: {
        name: 'beneficiary_userId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.commission_plans, {
      as: 'commission_plan',
      foreignKey: {
        name: 'commission_planId',
      },
      constraints: false,
    });

    db.commissions.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.commissions.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.commissions.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return commissions;
};


